------------------------------------------------------------
IF 0 = (SELECT count(*) from [sysobjects] where ([xtype] = 'U' or [xtype] = 'V') and [name] = 'ut_KeyCommands')
BEGIN
CREATE TABLE [dbo].[ut_KeyCommands]
(
   [RecId]  integer NOT NULL
  ,[MandId] integer DEFAULT 1
  ,[FormNo] integer DEFAULT 0
  ,[KeyNo] integer DEFAULT 0
  ,[Description] char(40) DEFAULT ' '
  ,[CmdId] integer DEFAULT 0
  ,[EventName] char(40) DEFAULT ' '
  CONSTRAINT [Pk_KeyCommands]  PRIMARY KEY NONCLUSTERED ( [RecId] )
)
END
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_KeyCommands_KeyDel')
  DROP TRIGGER [dbo].[tr_KeyCommands_KeyDel]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_KeyCommands_KeyUpd')
  DROP TRIGGER [dbo].[tr_KeyCommands_KeyUpd]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'U' and [name] = 'ut_KeyCommands_Keys')
  DROP TABLE [dbo].[ut_KeyCommands_Keys]
GO

IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_KeyCommands' and sc.[name] = 'FormNo')
BEGIN
  ALTER TABLE [dbo].[ut_KeyCommands] ADD [FormNo] integer NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_KeyCommands' and sc.[name] = 'KeyNo')
BEGIN
  ALTER TABLE [dbo].[ut_KeyCommands] ADD [KeyNo] integer NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_KeyCommands' and sc.[name] = 'Description')
BEGIN
  ALTER TABLE [dbo].[ut_KeyCommands] ADD [Description] char(40) NOT NULL DEFAULT ' '
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_KeyCommands' and sc.[name] = 'CmdId')
BEGIN
  ALTER TABLE [dbo].[ut_KeyCommands] ADD [CmdId] integer NOT NULL DEFAULT 0
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_KeyCommands' and sc.[name] = 'EventName')
BEGIN
  ALTER TABLE [dbo].[ut_KeyCommands] ADD [EventName] char(40) NOT NULL DEFAULT ' '
END
GO
IF 40 > (select length from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_KeyCommands' and sc.[name] = 'Description')
BEGIN
  ALTER TABLE [dbo].[ut_KeyCommands] ALTER COLUMN [Description] char(40)
END
GO
IF 40 > (select length from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_KeyCommands' and sc.[name] = 'EventName')
BEGIN
  ALTER TABLE [dbo].[ut_KeyCommands] ALTER COLUMN [EventName] char(40)
END
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'V' and [name] = 'KeyCommands')
  DROP VIEW [dbo].[KeyCommands]
GO
CREATE VIEW [dbo].[KeyCommands] AS
  SELECT * FROM [dbo].[ut_KeyCommands]
GO
CREATE TABLE [dbo].[ut_KeyCommands_Keys]
(
   [DataRecId]  integer NOT NULL
  ,[DataMandId] integer DEFAULT 1
  ,[Key00_Value] CHAR(18) NOT NULL
  CONSTRAINT [Pk_ut_KeyCommands_Keys]  PRIMARY KEY NONCLUSTERED ( [DataRecId] )
)
GO
CREATE TRIGGER [dbo].[tr_KeyCommands_KeyDel] ON [dbo].[ut_KeyCommands]
FOR DELETE
AS
  SET NOCOUNT ON
  DELETE FROM [dbo].[ut_KeyCommands_Keys] WITH (SERIALIZABLE)
  WHERE [DataRecId] IN (SELECT [RecId] FROM DELETED)
GO

CREATE TRIGGER [dbo].[tr_KeyCommands_KeyUpd] ON [dbo].[ut_KeyCommands]
FOR INSERT, UPDATE
AS
  SET NOCOUNT ON
  IF UPDATE([RecId]) OR UPDATE([MandId])
  BEGIN
    DELETE FROM [dbo].[ut_KeyCommands_Keys] WITH (SERIALIZABLE)
    WHERE [DataRecId] IN (SELECT [RecId] FROM DELETED)

    INSERT INTO [dbo].[ut_KeyCommands_Keys] WITH (SERIALIZABLE)
    ([DataRecId],[DataMandId],[Key00_Value])
    (SELECT [RecId],[MandId]
     ,UPPER(STR([FormNo],6,0)+STR([KeyNo],2,0)+STR(RecId,10))

    FROM INSERTED)
  END
  ELSE
  BEGIN
    UPDATE [dbo].[ut_KeyCommands_Keys] WITH (SERIALIZABLE) SET
    [Key00_Value] = UPPER(STR([FormNo],6,0)+STR([KeyNo],2,0)+STR([RecId],10))
    FROM INSERTED WHERE [DataRecId] = [RecId]
  END
GO

UPDATE [dbo].[ut_KeyCommands] SET RecId = RecId
GO


------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Add_KeyCommands')
  DROP PROCEDURE [dbo].[up_Add_KeyCommands]
GO
CREATE PROCEDURE [dbo].[up_Add_KeyCommands] AS
  DECLARE @NeueId integer
  SET @NeueId = (SELECT MAX(RecId) from [dbo].[ut_KeyCommands])
  IF @NeueId IS NULL SET @NeueId = 0
  SET @NeueId = @NeueId + 1
  INSERT INTO [dbo].[ut_KeyCommands] (RecId) VALUES( @NeueId )
  IF @@ERROR = 0
  BEGIN
    SELECT @NeueId AS RecId
    RETURN
  END
  SELECT 0 AS RecId
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd_KeyCommands')
  DROP PROCEDURE [dbo].[up_Upd_KeyCommands]
GO
CREATE PROCEDURE [dbo].[up_Upd_KeyCommands]
  @RI integer
 ,@Parm_FormNo integer
 ,@Parm_KeyNo integer
 ,@Parm_Description char(40)
 ,@Parm_CmdId integer
 ,@Parm_EventName char(40)
AS
--BEGIN TRANSACTION
UPDATE [dbo].[ut_KeyCommands] SET
     [FormNo] = @Parm_FormNo
    ,[KeyNo] = @Parm_KeyNo
    ,[Description] = RTRIM(@Parm_Description)
    ,[CmdId] = @Parm_CmdId
    ,[EventName] = RTRIM(@Parm_EventName)
  WHERE RecId = @RI
--COMMIT TRANSACTION
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel_KeyCommands')
  DROP PROCEDURE [dbo].[up_Sel_KeyCommands]
GO
CREATE PROCEDURE [dbo].[up_Sel_KeyCommands]
  @RI integer
AS
SELECT
     [FormNo]
    ,[KeyNo]
    ,[Description]
    ,[CmdId]
    ,[EventName]
  FROM [dbo].[ut_KeyCommands]
  WHERE RecId = @RI
GO
------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Del_KeyCommands')
  DROP PROCEDURE [dbo].[up_Del_KeyCommands]
GO
CREATE PROCEDURE [dbo].[up_Del_KeyCommands]
  @RI integer
AS
  DELETE FROM [dbo].[ut_KeyCommands] WHERE RecId = @RI
GO
------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Reorg_KeyCommands')
  DROP PROCEDURE [dbo].[up_Reorg_KeyCommands]
GO
CREATE PROCEDURE [dbo].[up_Reorg_KeyCommands]
  @bDbcc integer,@bRecId integer
AS
  IF (@bRecId = 1)
  BEGIN
    DECLARE  C        CURSOR FOR SELECT RecId FROM [dbo].[ut_KeyCommands] ORDER BY RecId
    DECLARE  @CurrId  integer
    DECLARE  @NextId  integer
    --BEGIN TRANSACTION
    OPEN C
    SET @NextId = 1
    FETCH NEXT FROM C INTO @CurrId
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
      IF @CurrId <> @NextId
      UPDATE [dbo].[ut_KeyCommands] SET RecId=@NextId WHERE CURRENT OF C
      SET @NextId = @NextId + 1
      FETCH NEXT FROM C INTO @CurrId
    END
    CLOSE C
    --COMMIT TRANSACTION
    DEALLOCATE C
  END

  IF (@bDbcc = 1)
  BEGIN
    DBCC DBREINDEX ( [ut_KeyCommands] )
  END

GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Append_KeyCommands')
  DROP PROCEDURE [dbo].[up_Append_KeyCommands]
GO
CREATE PROCEDURE [dbo].[up_Append_KeyCommands]
  @Parm_FormNo integer
 ,@Parm_KeyNo integer
 ,@Parm_Description char(40)
 ,@Parm_CmdId integer
 ,@Parm_EventName char(40)
AS
  DECLARE @NeueId    integer
  SET     @NeueId = (SELECT MAX(RecId) FROM [dbo].[ut_KeyCommands])
  IF @NeueId IS NULL SET @NeueId = 0
  SET @NeueId = @NeueId + 1
  INSERT INTO [dbo].[ut_KeyCommands] (
    RecId
   ,[FormNo]
   ,[KeyNo]
   ,[Description]
   ,[CmdId]
   ,[EventName]
     ) VALUES (
    @NeueId
   ,@Parm_FormNo
   ,@Parm_KeyNo
   ,RTRIM(@Parm_Description)
   ,@Parm_CmdId
   ,RTRIM(@Parm_EventName)
       )
  IF @@ERROR = 0
  BEGIN
    SELECT @NeueId AS RecId
    RETURN
  END
  SELECT 0 AS RecId
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_TrSel_KeyCommands')
  DROP PROCEDURE [dbo].[up_TrSel_KeyCommands]
GO
CREATE PROCEDURE [dbo].[up_TrSel_KeyCommands]
AS
  SELECT   RecId,
      LTRIM(RTRIM([Description]))
      +LTRIM(RTRIM([EventName]))
    AS Data
  FROM     [dbo].[ut_KeyCommands]
  WHERE    RecId > 0
  ORDER BY RecId
GO

CREATE INDEX [Ik_Key00] ON [dbo].[ut_KeyCommands_Keys]
( [Key00_Value],[DataRecId] )
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_KeyCommands_Key00')
  DROP PROCEDURE [dbo].[up_First_KeyCommands_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_KeyCommands_Key00')
  DROP PROCEDURE [dbo].[up_Last_KeyCommands_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_KeyCommands_Key00')
  DROP PROCEDURE [dbo].[up_Prior_KeyCommands_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_KeyCommands_Key00')
  DROP PROCEDURE [dbo].[up_Next_KeyCommands_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_KeyCommands_Key00')
  DROP PROCEDURE [dbo].[up_Prior50_KeyCommands_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_KeyCommands_Key00')
  DROP PROCEDURE [dbo].[up_Next50_KeyCommands_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_KeyCommands_Key00')
  DROP PROCEDURE [dbo].[up_FindL_KeyCommands_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_KeyCommands_Key00')
  DROP PROCEDURE [dbo].[up_FindF_KeyCommands_Key00]
GO

CREATE PROCEDURE [dbo].[up_First_KeyCommands_Key00]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_KeyCommands_Keys] ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Last_KeyCommands_Key00]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_KeyCommands_Keys] ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next_KeyCommands_Key00] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_KeyCommands_Keys]
  WHERE [Key00_Value] > (SELECT [Key00_Value] FROM [dbo].[ut_KeyCommands_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior_KeyCommands_Key00] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_KeyCommands_Keys]
  WHERE [Key00_Value] < (SELECT [Key00_Value] FROM [dbo].[ut_KeyCommands_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next50_KeyCommands_Key00] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_KeyCommands_Keys]
  WHERE [Key00_Value] > (SELECT [Key00_Value] FROM [dbo].[ut_KeyCommands_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior50_KeyCommands_Key00] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_KeyCommands_Keys]
  WHERE [Key00_Value] < (SELECT [Key00_Value] FROM [dbo].[ut_KeyCommands_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_FindF_KeyCommands_Key00] @xKey char(128),@xLen integer
AS
  SELECT a.[DataRecId] FROM
    ( SELECT TOP 1 [DataRecId],[Key00_Value] AS Key_Value FROM [dbo].[ut_KeyCommands_Keys]
      WHERE [Key00_Value] >= SUBSTRING(@xKey,1,@xLen)
      ORDER BY [Key00_Value]
    ) a
  WHERE a.Key_Value like SUBSTRING(@xKey,1,@xLen)+'%'
GO

CREATE PROCEDURE [dbo].[up_FindL_KeyCommands_Key00] @xKey char(128),@xLen integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_KeyCommands_Keys]
  WHERE [Key00_Value] like SUBSTRING(@xKey,1,@xLen)+'%'
  ORDER BY [Key00_Value] DESC
GO

